#!/usr/bin/perl
#
# OS_Version.pl
# Copyright (c) 2009 silex technology, Inc. All rights reserverd.
#

$sys_ver_file = "/System/Library/CoreServices/SystemVersion.plist";

sub version_string_to_hex
{
	$ver_str = @_[0];

	@ver_array = split(/\./, $ver_str);

	$ver_value = $ver_array[0];
	$ver_value <<= 8;
	$ver_value += $ver_array[1];
	$ver_value <<= 8;
	$ver_value += $ver_array[2];

	return $ver_value;
}

$target_ver = $ARGV[0];

if (!open(FH, $sys_ver_file)) {
	die
}

$ret = -1;

while ($line = <FH>)
{
	if ($line =~ "ProductVersion")
	{
		$ver_str = <FH>;
		$ver_str =~ s/\t//g;
		$ver_str =~ s/<\/string>//g;
		$ver_str =~ s/<string>//g;

		$ver1 = version_string_to_hex($ver_str);

		$ver2 = version_string_to_hex($target_ver);

		if ($ver1 >= $ver2) {
			$ret = 1;
		}
		else {
			$ret = 0;
		}
	}
}

close(FH);

exit($ret);